This commit is contained in:
David Katleman 2012-05-16 22:06:41 -07:00
commit 74e0cc2fe5
2 changed files with 53 additions and 17 deletions

View File

@ -1,7 +1,7 @@
#!/bin/sh #!/bin/sh
# #
# Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved. # Copyright (c) 2010, 2012, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER. # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
# #
# This code is free software; you can redistribute it and/or modify it # This code is free software; you can redistribute it and/or modify it
@ -26,7 +26,7 @@
# #
# Get clones of all nested repositories # Get clones of all nested repositories
sh ./make/scripts/hgforest.sh clone sh ./make/scripts/hgforest.sh clone $*
# Update all existing repositories to the latest sources # Update all existing repositories to the latest sources
sh ./make/scripts/hgforest.sh pull -u sh ./make/scripts/hgforest.sh pull -u

View File

@ -1,7 +1,7 @@
#!/bin/sh #!/bin/sh
# #
# Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved. # Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER. # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
# #
# This code is free software; you can redistribute it and/or modify it # This code is free software; you can redistribute it and/or modify it
@ -24,6 +24,8 @@
# #
# Shell script for a fast parallel forest command # Shell script for a fast parallel forest command
command="$1"
pull_extra_base="$2"
tmp=/tmp/forest.$$ tmp=/tmp/forest.$$
rm -f -r ${tmp} rm -f -r ${tmp}
@ -35,40 +37,58 @@ trap 'rm -f -r ${tmp}' EXIT
# Only look in specific locations for possible forests (avoids long searches) # Only look in specific locations for possible forests (avoids long searches)
pull_default="" pull_default=""
if [ "$1" = "clone" -o "$1" = "fclone" ] ; then repos=""
repos_extra=""
if [ "${command}" = "clone" -o "${command}" = "fclone" ] ; then
subrepos="corba jaxp jaxws langtools jdk hotspot" subrepos="corba jaxp jaxws langtools jdk hotspot"
if [ -f .hg/hgrc ] ; then if [ -f .hg/hgrc ] ; then
pull_default=`hg paths default` pull_default=`hg paths default`
fi
if [ "${pull_default}" = "" ] ; then if [ "${pull_default}" = "" ] ; then
echo "ERROR: Need initial clone with 'hg paths default' defined" echo "ERROR: Need initial clone with 'hg paths default' defined"
exit 1 exit 1
fi fi
repos="" fi
if [ "${pull_default}" = "" ] ; then
echo "ERROR: Need initial repository to use this script"
exit 1
fi
for i in ${subrepos} ; do for i in ${subrepos} ; do
if [ ! -f ${i}/.hg/hgrc ] ; then if [ ! -f ${i}/.hg/hgrc ] ; then
repos="${repos} ${i}" repos="${repos} ${i}"
fi fi
done done
if [ "${pull_extra_base}" != "" ] ; then
subrepos_extra="jdk/src/closed jdk/make/closed jdk/test/closed hotspot/src/closed hotspot/test/closed deploy install sponsors pubs"
pull_default_tail=`echo ${pull_default} | sed -e 's@^.*://[^/]*/\(.*\)@\1@'`
pull_extra="${pull_extra_base}/${pull_default_tail}"
for i in ${subrepos_extra} ; do
if [ ! -f ${i}/.hg/hgrc ] ; then
repos_extra="${repos_extra} ${i}"
fi
done
fi
at_a_time=2 at_a_time=2
# Any repos to deal with?
if [ "${repos}" = "" -a "${repos_extra}" = "" ] ; then
echo "No repositories to clone."
exit
fi
else else
hgdirs=`ls -d ./.hg ./*/.hg ./*/*/.hg ./*/*/*/.hg ./*/*/*/*/.hg 2>/dev/null` hgdirs=`ls -d ./.hg ./*/.hg ./*/*/.hg ./*/*/*/.hg ./*/*/*/*/.hg 2>/dev/null`
# Derive repository names from the .hg directory locations # Derive repository names from the .hg directory locations
repos=""
for i in ${hgdirs} ; do for i in ${hgdirs} ; do
repos="${repos} `echo ${i} | sed -e 's@/.hg$@@'`" repos="${repos} `echo ${i} | sed -e 's@/.hg$@@'`"
done done
at_a_time=8 at_a_time=8
fi # Any repos to deal with?
if [ "${repos}" = "" ] ; then
# Any repos to deal with?
if [ "${repos}" = "" ] ; then
echo "No repositories to process." echo "No repositories to process."
exit exit
fi
fi fi
# Echo out what repositories we will process # Echo out what repositories we will clone
echo "# Repos: ${repos}" echo "# Repos: ${repos} ${repos_extra}"
# Run the supplied command on all repos in parallel, save output until end # Run the supplied command on all repos in parallel, save output until end
n=0 n=0
@ -77,8 +97,8 @@ for i in ${repos} ; do
n=`expr ${n} '+' 1` n=`expr ${n} '+' 1`
( (
( (
if [ "$1" = "clone" -o "$1" = "fclone" ] ; then if [ "${command}" = "clone" -o "${command}" = "fclone" ] ; then
cline="hg $* ${pull_default}/${i} ${i}" cline="hg clone ${pull_default}/${i} ${i}"
echo "# ${cline}" echo "# ${cline}"
( eval "${cline}" ) ( eval "${cline}" )
else else
@ -92,6 +112,22 @@ for i in ${repos} ; do
sleep 5 sleep 5
fi fi
done done
if [ "${repos_extra}" != "" ] ; then
for i in ${repos_extra} ; do
echo "Starting on ${i}"
n=`expr ${n} '+' 1`
(
(
cline="hg clone ${pull_extra}/${i} ${i}"
echo "# ${cline}"
( eval "${cline}" )
echo "# exit code $?"
) > ${tmp}/repo.${n} 2>&1 ; cat ${tmp}/repo.${n} ) &
if [ `expr ${n} '%' ${at_a_time}` -eq 0 ] ; then
sleep 5
fi
done
fi
# Wait for all hg commands to complete # Wait for all hg commands to complete
wait wait